﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using BinaryTree;
using System.Collections.Generic;


namespace BinarySearchTreeTest
{
    [TestClass]
    public class BinarySearchTreeTests
    {
        [TestMethod]
        public void TraverseInorderTest()
        {
            var tree = Setup();
            string result = tree.TraverseInorder();
            Assert.AreEqual("5 10 12 14 18 25", result, "Traverse inorder didn't sort the items correctly");
        }
        [TestMethod]
        public void TraversePostorderTest()
        {
            var tree = Setup();
            //Act
            string result = tree.TraversePostorder();

            //Assert
            Assert.AreEqual(result, "25 18 14 12 10 5");
        }

        [TestMethod, ExpectedException(typeof(ArgumentException))]
        public void AddExistingValue()
        {
            var tree = Setup();
            tree.Add(12);
        }

        [TestMethod]
        public void AddNonExistingValue()
        {
            Node<int> root = new Node<int>(12);
            BinarySearchTree tree = new BinarySearchTree(root);

            tree.Add(5);
        }

        private BinarySearchTree Setup()
        {
            Node<int> root = new Node<int>(25);
            BinarySearchTree tree = new BinarySearchTree(root);
            tree.Add(5);
            tree.Add(10);
            tree.Add(12);
            tree.Add(18);
            tree.Add(14);
            return tree;
        }
    }
}
