﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using BinaryTree;
using System.Collections.Generic;

namespace BinarySearchTreeTest
{
    [TestClass]
    public class ComplexClassTests
    {
        private IList<int> list=new List<int>();

        private ComplexClass Setup()
        {
            SimpleClassOne simpleOne = new SimpleClassOne(5, 6,3);
            SimpleClassTwo simpleTwo = new SimpleClassTwo("Hello", "I'm ", "Joro");
            SimpleClassThree simpleThree = new SimpleClassThree("number", 5);
            ComplexClass item = new ComplexClass(simpleOne, simpleTwo, simpleThree);
            return item;

        }

        [TestMethod]
        public void TestDoWork()
        {
            ComplexClass item = Setup();
            Assert.AreEqual(5, item.DoWork(), "The DoWork method doesn't work properly");
            Assert.IsTrue(list.Contains(5));
        }

        [TestMethod]
        public void TestHello()
        {
            var item = Setup();
            Assert.AreEqual("Hello", item.SayHello(), "The hello method failed");
            Assert.IsTrue(list.Contains(5));
            
        }
        [TestMethod]
        public void TestDoWorkWithWrongData()
        {
            var item = Setup();
            Assert.AreNotEqual(8, item.DoWork(), "The DoWork method has duplicate results");
            Assert.IsTrue(list.Contains(5));
        }

        [TestCleanup]
        public void Cleanup()
        {
            list.Clear();
        }

    }
}
