﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using BinaryTree;
using System.Collections.Generic;


namespace BinarySearchTreeTest
{
    [TestClass]
    public class UnitTest1
    {
        [TestMethod]
        public void TraverseInorderTest()
        {            
            //Setup
            Node<int> root = new Node<int>(25);
            BinarySearchTree tree = new BinarySearchTree(root);
            tree.Add(5);
            tree.Add(10);
            tree.Add(12);
            tree.Add(18);
            tree.Add(14);

            //Act
            string output = tree.TraverseInorder();
            List<int> expected = new List<int>();
            List<int> result = new List<int>();
            expected.Add(5);
            expected.Add(10);
            expected.Add(12);
            expected.Add(14);
            expected.Add(18);
            expected.Add(25);
            string[] numbers = output.Split(' ');
            foreach (var item in numbers)
            {
                int number = int.Parse(item);
                result.Add(number);
            }

            //Assert
            for (int i = 0; i < result.Count; i++)
            {
                if (result[i] != expected[i])
                {
                    Assert.Fail("Method doesn't work");
                }
            }
        }
        [TestMethod]
        public void TraversePostorderTest()
        {
            //Setup
            Node<int> root = new Node<int>(25);
            BinarySearchTree tree = new BinarySearchTree(root);
            tree.Add(5);
            tree.Add(10);
            tree.Add(12);
            tree.Add(18);
            tree.Add(14);

            //Act
            string result = tree.TraversePostorder();

            //Assert
            Assert.AreEqual(result, "25 18 14 12 10 5");
        }
        [TestMethod, ExpectedException(typeof(ArgumentException))]
        public void AddExistingValue()
        {
            //Setup
            Node<int> root = new Node<int>(25);
            BinarySearchTree tree = new BinarySearchTree(root);
            tree.Add(5);
            tree.Add(10);
            tree.Add(12);
            tree.Add(18);
            tree.Add(14);

            //Act
            tree.Add(12);

            //Assert
            Assert.Fail("Метода адд трябваше да хвърля светкавици и гръмотевици");
        }

        [TestMethod]
        public void AddNonExistingValue()
        {
            //Setup
            Node<int> root = new Node<int>(25);
            BinarySearchTree tree = new BinarySearchTree(root);
            tree.Add(5);
            tree.Add(10);
            tree.Add(12);
            tree.Add(18);
            tree.Add(14);
            
            //Act
            string allElements = tree.TraverseInorder();
            string[] elements = allElements.Split(' ');
            int largest = int.Parse(elements[elements.Length - 1]);
            for (int i = largest+1; i < largest*2; i++)
            {
                tree.Add(i);
            }

            //Assert
            Assert.IsTrue(true, "Something wrong");
        }
    }
}
